std::__debug::map< _Key, _Tp, _Compare, _Allocator > Class Template Reference

`#include <map.h>`

Inheritance diagram for std::__debug::map< _Key, _Tp, _Compare, _Allocator >:
[legend]

## Public Types

typedef _Allocator | allocator_type
typedef __gnu_debug::_Safe_iterator< _Base_const_iterator, map > | const_iterator
typedef _Base::const_pointer | const_pointer
typedef _Base::const_reference | const_reference
typedef std::reverse_iterator< const_iterator > | const_reverse_iterator
typedef _Base::difference_type | difference_type
typedef __gnu_debug::_Safe_iterator< _Base_iterator, map > | iterator
typedef _Compare | key_compare
typedef _Key | key_type
typedef _Tp | mapped_type
typedef _Base::pointer | pointer
typedef _Base::reference | reference
typedef std::reverse_iterator< iterator > | reverse_iterator
typedef _Base::size_type | size_type
typedef std::pair< const _Key, _Tp > | value_type

## Public Member Functions

template<typename _InputIterator >
| map (_InputIterator __first, _InputIterator __last, const _Compare &__comp=_Compare(), const _Allocator &__a=_Allocator())
template<typename _InputIterator >
| map (_InputIterator __first, _InputIterator __last, const allocator_type &__a)
| map (const _Base &__x)
| map (const _Compare &__comp, const _Allocator &__a=_Allocator())
| map (const allocator_type &__a)
| map (const map &)=default
| map (const map &__m, const allocator_type &__a)
| map (initializer_list< value_type > __l, const _Compare &__c=_Compare(), const allocator_type &__a=allocator_type())
| map (initializer_list< value_type > __l, const allocator_type &__a)
| map (map &&)=default
| map (map &&__m, const allocator_type &__a) noexcept(noexcept(_Base(std::move(__m._M_base()), __a)))
const _Base & | _M_base () const noexcept
_Base & | _M_base () noexcept
void | _M_swap (_Safe_container &__x) noexcept
const_iterator | begin () const noexcept
iterator | begin () noexcept
const_iterator | cbegin () const noexcept
const_iterator | cend () const noexcept
void | clear () noexcept
const_reverse_iterator | crbegin () const noexcept
const_reverse_iterator | crend () const noexcept
template<typename... _Args>
std::pair< iterator, bool > | emplace (_Args &&... __args)
template<typename... _Args>
iterator | emplace_hint (const_iterator __pos, _Args &&... __args)
const_iterator | end () const noexcept
iterator | end () noexcept
template<typename _Kt , typename _Req = typename __has_is_transparent<_Compare, _Kt>::type>
std::pair< iterator, iterator > | equal_range (const _Kt &__x)
template<typename _Kt , typename _Req = typename __has_is_transparent<_Compare, _Kt>::type>
std::pair< const_iterator, const_iterator > | equal_range (const _Kt &__x) const
std::pair< iterator, iterator > | equal_range (const key_type &__x)
std::pair< const_iterator, const_iterator > | equal_range (const key_type &__x) const
size_type | erase (const key_type &__x)
iterator | erase (const_iterator __first, const_iterator __last)
iterator | erase (const_iterator __position)
_GLIBCXX_ABI_TAG_CXX11 iterator | erase (iterator __position)
template<typename _Kt , typename _Req = typename __has_is_transparent<_Compare, _Kt>::type>
iterator | find (const _Kt &__x)
template<typename _Kt , typename _Req = typename __has_is_transparent<_Compare, _Kt>::type>
const_iterator | find (const _Kt &__x) const
iterator | find (const key_type &__x)
const_iterator | find (const key_type &__x) const
template<typename _InputIterator >
void | insert (_InputIterator __first, _InputIterator __last)
template<typename _Pair , typename = typename std::enable_if<std::is_constructible<value_type, _Pair&&>::value>::type>
std::pair< iterator, bool > | insert (_Pair &&__x)
std::pair< iterator, bool > | insert (const value_type &__x)
template<typename _Pair , typename = typename std::enable_if<std::is_constructible<value_type, _Pair&&>::value>::type>
iterator | insert (const_iterator __position, _Pair &&__x)
iterator | insert (const_iterator __position, const value_type &__x)
iterator | insert (const_iterator __position, value_type &&__x)
void | insert (std::initializer_list< value_type > __list)
std::pair< iterator, bool > | insert (value_type &&__x)
template<typename _Kt , typename _Req = typename __has_is_transparent<_Compare, _Kt>::type>
iterator | lower_bound (const _Kt &__x)
template<typename _Kt , typename _Req = typename __has_is_transparent<_Compare, _Kt>::type>
const_iterator | lower_bound (const _Kt &__x) const
iterator | lower_bound (const key_type &__x)
const_iterator | lower_bound (const key_type &__x) const
map & | operator= (const map &)=default
map & | operator= (initializer_list< value_type > __l)
map & | operator= (map &&)=default
const_reverse_iterator | rbegin () const noexcept
reverse_iterator | rbegin () noexcept
const_reverse_iterator | rend () const noexcept
reverse_iterator | rend () noexcept
void | swap (map &__x) noexcept(/*conditional */)
template<typename _Kt , typename _Req = typename __has_is_transparent<_Compare, _Kt>::type>
iterator | upper_bound (const _Kt &__x)
template<typename _Kt , typename _Req = typename __has_is_transparent<_Compare, _Kt>::type>
const_iterator | upper_bound (const _Kt &__x) const
iterator | upper_bound (const key_type &__x)
const_iterator | upper_bound (const key_type &__x) const

## Protected Member Functions

_Safe_container & | _M_safe () noexcept

## Friends

template<typename _ItT , typename _SeqT , typename _CatT >
class | ::__gnu_debug::_Safe_iterator

## Detailed Description

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>
class std::__debug::map< _Key, _Tp, _Compare, _Allocator >

Class std::map with safety/checking/debug instrumentation.

Definition at line 44 of file debug/map.h.

## Member Typedef Documentation

## allocator_type

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

typedef _Allocator std::__debug::map< _Key, _Tp, _Compare, _Allocator >::allocator_type

Definition at line 68 of file debug/map.h.

## const_iterator

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

typedef __gnu_debug::_Safe_iterator<_Base_const_iterator, map> std::__debug::map< _Key, _Tp, _Compare, _Allocator >::const_iterator

Definition at line 75 of file debug/map.h.

## const_pointer

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

typedef _Base::const_pointer std::__debug::map< _Key, _Tp, _Compare, _Allocator >::const_pointer

Definition at line 80 of file debug/map.h.

## const_reference

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

typedef _Base::const_reference std::__debug::map< _Key, _Tp, _Compare, _Allocator >::const_reference

Definition at line 70 of file debug/map.h.

## const_reverse_iterator

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

typedef std::reverse_iterator<const_iterator> std::__debug::map< _Key, _Tp, _Compare, _Allocator >::const_reverse_iterator

Definition at line 82 of file debug/map.h.

## difference_type

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

typedef _Base::difference_type std::__debug::map< _Key, _Tp, _Compare, _Allocator >::difference_type

Definition at line 78 of file debug/map.h.

## iterator

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

typedef __gnu_debug::_Safe_iterator<_Base_iterator, map> std::__debug::map< _Key, _Tp, _Compare, _Allocator >::iterator

Definition at line 73 of file debug/map.h.

## key_compare

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

typedef _Compare std::__debug::map< _Key, _Tp, _Compare, _Allocator >::key_compare

Definition at line 67 of file debug/map.h.

## key_type

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

typedef _Key std::__debug::map< _Key, _Tp, _Compare, _Allocator >::key_type

Definition at line 64 of file debug/map.h.

## mapped_type

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

typedef _Tp std::__debug::map< _Key, _Tp, _Compare, _Allocator >::mapped_type

Definition at line 65 of file debug/map.h.

## pointer

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

typedef _Base::pointer std::__debug::map< _Key, _Tp, _Compare, _Allocator >::pointer

Definition at line 79 of file debug/map.h.

## reference

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

typedef _Base::reference std::__debug::map< _Key, _Tp, _Compare, _Allocator >::reference

Definition at line 69 of file debug/map.h.

## reverse_iterator

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

typedef std::reverse_iterator<iterator> std::__debug::map< _Key, _Tp, _Compare, _Allocator >::reverse_iterator

Definition at line 81 of file debug/map.h.

## size_type

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

typedef _Base::size_type std::__debug::map< _Key, _Tp, _Compare, _Allocator >::size_type

Definition at line 77 of file debug/map.h.

## value_type

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

typedef std::pair<const _Key, _Tp> std::__debug::map< _Key, _Tp, _Compare, _Allocator >::value_type

Definition at line 66 of file debug/map.h.

## Constructor & Destructor Documentation

## map() [1/9]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

std::__debug::map< _Key, _Tp, _Compare, _Allocator >::map | ( | initializer_list< value_type > | __l,
|  | const _Compare & | __c = `_Compare()`,
|  | const allocator_type & | __a = `allocator_type()`
| ) |  |

inline

Definition at line 98 of file debug/map.h.

## map() [2/9]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

std::__debug::map< _Key, _Tp, _Compare, _Allocator >::map | ( | const allocator_type & | __a | ) |

inline explicit

Definition at line 104 of file debug/map.h.

## map() [3/9]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

std::__debug::map< _Key, _Tp, _Compare, _Allocator >::map | ( | const map< _Key, _Tp, _Compare, _Allocator > & | __m,
|  | const allocator_type & | __a
| ) |  |

inline

Definition at line 107 of file debug/map.h.

## map() [4/9]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

std::__debug::map< _Key, _Tp, _Compare, _Allocator >::map | ( | map< _Key, _Tp, _Compare, _Allocator > && | __m,
|  | const allocator_type & | __a
| ) |  |

inline noexcept

Definition at line 110 of file debug/map.h.

## map() [5/9]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

std::__debug::map< _Key, _Tp, _Compare, _Allocator >::map | ( | initializer_list< value_type > | __l,
|  | const allocator_type & | __a
| ) |  |

inline

Definition at line 115 of file debug/map.h.

## map() [6/9]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>
template<typename _InputIterator >

std::__debug::map< _Key, _Tp, _Compare, _Allocator >::map | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | const allocator_type & | __a
| ) |  |

inline

Definition at line 119 of file debug/map.h.

## map() [7/9]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

std::__debug::map< _Key, _Tp, _Compare, _Allocator >::map | ( | const _Base & | __x | ) |

inline

Definition at line 129 of file debug/map.h.

## map() [8/9]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

std::__debug::map< _Key, _Tp, _Compare, _Allocator >::map | ( | const _Compare & | __comp,
|  | const _Allocator & | __a = `_Allocator()`
| ) |  |

inline explicit

Definition at line 132 of file debug/map.h.

## map() [9/9]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>
template<typename _InputIterator >

std::__debug::map< _Key, _Tp, _Compare, _Allocator >::map | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | const _Compare & | __comp = `_Compare()`,
|  | const _Allocator & | __a = `_Allocator()`
| ) |  |

inline

Definition at line 137 of file debug/map.h.

## Member Function Documentation

## _M_base() [1/2]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

const _Base & std::__debug::map< _Key, _Tp, _Compare, _Allocator >::_M_base | ( |  | ) | const

inline noexcept

Definition at line 698 of file debug/map.h.

## _M_base() [2/2]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

_Base & std::__debug::map< _Key, _Tp, _Compare, _Allocator >::_M_base | ( |  | ) |

inline noexcept

Definition at line 695 of file debug/map.h.

## _M_safe()

template<typename _SafeContainer , typename _Alloc , template< typename > class _SafeBase, bool _IsCxx11AllocatorAware = true>

_Safe_container & __gnu_debug::_Safe_container< _SafeContainer, _Alloc, _SafeBase, _IsCxx11AllocatorAware >::_M_safe | ( |  | ) |

inline protected noexcept inherited

Definition at line 52 of file safe_container.h.

## _M_swap()

template<typename _SafeContainer , typename _Alloc , template< typename > class _SafeBase, bool _IsCxx11AllocatorAware = true>

void __gnu_debug::_Safe_container< _SafeContainer, _Alloc, _SafeBase, _IsCxx11AllocatorAware >::_M_swap | ( | _Safe_container< _SafeContainer, _Alloc, _SafeBase, _IsCxx11AllocatorAware > & | __x | ) |

inline noexcept inherited

Definition at line 104 of file safe_container.h.

## begin() [1/2]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

const_iterator std::__debug::map< _Key, _Tp, _Compare, _Allocator >::begin | ( |  | ) | const

inline noexcept

Definition at line 179 of file debug/map.h.

## begin() [2/2]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::__debug::map< _Key, _Tp, _Compare, _Allocator >::begin | ( |  | ) |

inline noexcept

Definition at line 175 of file debug/map.h.

## cbegin()

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

const_iterator std::__debug::map< _Key, _Tp, _Compare, _Allocator >::cbegin | ( |  | ) | const

inline noexcept

Definition at line 208 of file debug/map.h.

## cend()

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

const_iterator std::__debug::map< _Key, _Tp, _Compare, _Allocator >::cend | ( |  | ) | const

inline noexcept

Definition at line 212 of file debug/map.h.

## clear()

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

void std::__debug::map< _Key, _Tp, _Compare, _Allocator >::clear | ( |  | ) |

inline noexcept

Definition at line 561 of file debug/map.h.

## crbegin()

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

const_reverse_iterator std::__debug::map< _Key, _Tp, _Compare, _Allocator >::crbegin | ( |  | ) | const

inline noexcept

Definition at line 216 of file debug/map.h.

## crend()

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

const_reverse_iterator std::__debug::map< _Key, _Tp, _Compare, _Allocator >::crend | ( |  | ) | const

inline noexcept

Definition at line 220 of file debug/map.h.

## emplace()

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>
template<typename... _Args>

std::pair< iterator, bool > std::__debug::map< _Key, _Tp, _Compare, _Allocator >::emplace | ( | _Args &&... | __args | ) |

inline

Definition at line 240 of file debug/map.h.

## emplace_hint()

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>
template<typename... _Args>

iterator std::__debug::map< _Key, _Tp, _Compare, _Allocator >::emplace_hint | ( | const_iterator | __pos,
|  | _Args &&... | __args
| ) |  |

inline

Definition at line 248 of file debug/map.h.

## end() [1/2]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

const_iterator std::__debug::map< _Key, _Tp, _Compare, _Allocator >::end | ( |  | ) | const

inline noexcept

Definition at line 187 of file debug/map.h.

## end() [2/2]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::__debug::map< _Key, _Tp, _Compare, _Allocator >::end | ( |  | ) |

inline noexcept

Definition at line 183 of file debug/map.h.

## equal_range() [1/4]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>
template<typename _Kt , typename _Req = typename __has_is_transparent<_Compare, _Kt>::type>

std::pair< iterator, iterator > std::__debug::map< _Key, _Tp, _Compare, _Allocator >::equal_range | ( | const _Kt & | __x | ) |

inline

Definition at line 666 of file debug/map.h.

## equal_range() [2/4]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>
template<typename _Kt , typename _Req = typename __has_is_transparent<_Compare, _Kt>::type>

std::pair< const_iterator, const_iterator > std::__debug::map< _Key, _Tp, _Compare, _Allocator >::equal_range | ( | const _Kt & | __x | ) | const

inline

Definition at line 687 of file debug/map.h.

## equal_range() [3/4]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

std::pair< iterator, iterator > std::__debug::map< _Key, _Tp, _Compare, _Allocator >::equal_range | ( | const key_type & | __x | ) |

inline

Definition at line 653 of file debug/map.h.

## equal_range() [4/4]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

std::pair< const_iterator, const_iterator > std::__debug::map< _Key, _Tp, _Compare, _Allocator >::equal_range | ( | const key_type & | __x | ) | const

inline

Definition at line 674 of file debug/map.h.

## erase() [1/4]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

size_type std::__debug::map< _Key, _Tp, _Compare, _Allocator >::erase | ( | const key_type & | __x | ) |

inline

Definition at line 500 of file debug/map.h.

## erase() [2/4]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::__debug::map< _Key, _Tp, _Compare, _Allocator >::erase | ( | const_iterator | __first,
|  | const_iterator | __last
| ) |  |

inline

Definition at line 515 of file debug/map.h.

## erase() [3/4]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::__debug::map< _Key, _Tp, _Compare, _Allocator >::erase | ( | const_iterator | __position | ) |

inline

Definition at line 478 of file debug/map.h.

## erase() [4/4]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

_GLIBCXX_ABI_TAG_CXX11 iterator std::__debug::map< _Key, _Tp, _Compare, _Allocator >::erase | ( | iterator | __position | ) |

inline

Definition at line 487 of file debug/map.h.

## find() [1/4]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>
template<typename _Kt , typename _Req = typename __has_is_transparent<_Compare, _Kt>::type>

iterator std::__debug::map< _Key, _Tp, _Compare, _Allocator >::find | ( | const _Kt & | __x | ) |

inline

Definition at line 581 of file debug/map.h.

## find() [2/4]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>
template<typename _Kt , typename _Req = typename __has_is_transparent<_Compare, _Kt>::type>

const_iterator std::__debug::map< _Key, _Tp, _Compare, _Allocator >::find | ( | const _Kt & | __x | ) | const

inline

Definition at line 594 of file debug/map.h.

## find() [3/4]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::__debug::map< _Key, _Tp, _Compare, _Allocator >::find | ( | const key_type & | __x | ) |

inline

Definition at line 573 of file debug/map.h.

## find() [4/4]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

const_iterator std::__debug::map< _Key, _Tp, _Compare, _Allocator >::find | ( | const key_type & | __x | ) | const

inline

Definition at line 586 of file debug/map.h.

## insert() [1/8]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>
template<typename _InputIterator >

void std::__debug::map< _Key, _Tp, _Compare, _Allocator >::insert | ( | _InputIterator | __first,
|  | _InputIterator | __last
| ) |  |

inline

Definition at line 332 of file debug/map.h.

## insert() [2/8]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>
template<typename _Pair , typename = typename std::enable_if<std::is_constructible<value_type, _Pair&&>::value>::type>

std::pair< iterator, bool > std::__debug::map< _Key, _Tp, _Compare, _Allocator >::insert | ( | _Pair && | __x | ) |

inline

Definition at line 281 of file debug/map.h.

## insert() [3/8]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

std::pair< iterator, bool > std::__debug::map< _Key, _Tp, _Compare, _Allocator >::insert | ( | const value_type & | __x | ) |

inline

Definition at line 260 of file debug/map.h.

## insert() [4/8]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>
template<typename _Pair , typename = typename std::enable_if<std::is_constructible<value_type, _Pair&&>::value>::type>

iterator std::__debug::map< _Key, _Tp, _Compare, _Allocator >::insert | ( | const_iterator | __position,
|  | _Pair && | __x
| ) |  |

inline

Definition at line 319 of file debug/map.h.

## insert() [5/8]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::__debug::map< _Key, _Tp, _Compare, _Allocator >::insert | ( | const_iterator | __position,
|  | const value_type & | __x
| ) |  |

inline

Definition at line 296 of file debug/map.h.

## insert() [6/8]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::__debug::map< _Key, _Tp, _Compare, _Allocator >::insert | ( | const_iterator | __position,
|  | value_type && | __x
| ) |  |

inline

Definition at line 309 of file debug/map.h.

## insert() [7/8]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

void std::__debug::map< _Key, _Tp, _Compare, _Allocator >::insert | ( | std::initializer_list< value_type > | __list | ) |

inline

Definition at line 290 of file debug/map.h.

## insert() [8/8]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

std::pair< iterator, bool > std::__debug::map< _Key, _Tp, _Compare, _Allocator >::insert | ( | value_type && | __x | ) |

inline

Definition at line 271 of file debug/map.h.

## lower_bound() [1/4]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>
template<typename _Kt , typename _Req = typename __has_is_transparent<_Compare, _Kt>::type>

iterator std::__debug::map< _Key, _Tp, _Compare, _Allocator >::lower_bound | ( | const _Kt & | __x | ) |

inline

Definition at line 609 of file debug/map.h.

## lower_bound() [2/4]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>
template<typename _Kt , typename _Req = typename __has_is_transparent<_Compare, _Kt>::type>

const_iterator std::__debug::map< _Key, _Tp, _Compare, _Allocator >::lower_bound | ( | const _Kt & | __x | ) | const

inline

Definition at line 622 of file debug/map.h.

## lower_bound() [3/4]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::__debug::map< _Key, _Tp, _Compare, _Allocator >::lower_bound | ( | const key_type & | __x | ) |

inline

Definition at line 601 of file debug/map.h.

## lower_bound() [4/4]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

const_iterator std::__debug::map< _Key, _Tp, _Compare, _Allocator >::lower_bound | ( | const key_type & | __x | ) | const

inline

Definition at line 614 of file debug/map.h.

## operator=()

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

map & std::__debug::map< _Key, _Tp, _Compare, _Allocator >::operator= | ( | initializer_list< value_type > | __l | ) |

inline

Definition at line 161 of file debug/map.h.

## rbegin() [1/2]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

const_reverse_iterator std::__debug::map< _Key, _Tp, _Compare, _Allocator >::rbegin | ( |  | ) | const

inline noexcept

Definition at line 195 of file debug/map.h.

## rbegin() [2/2]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

reverse_iterator std::__debug::map< _Key, _Tp, _Compare, _Allocator >::rbegin | ( |  | ) |

inline noexcept

Definition at line 191 of file debug/map.h.

## rend() [1/2]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

const_reverse_iterator std::__debug::map< _Key, _Tp, _Compare, _Allocator >::rend | ( |  | ) | const

inline noexcept

Definition at line 203 of file debug/map.h.

## rend() [2/2]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

reverse_iterator std::__debug::map< _Key, _Tp, _Compare, _Allocator >::rend | ( |  | ) |

inline noexcept

Definition at line 199 of file debug/map.h.

## swap()

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

void std::__debug::map< _Key, _Tp, _Compare, _Allocator >::swap | ( | map< _Key, _Tp, _Compare, _Allocator > & | __x | ) |

inline noexcept

Definition at line 553 of file debug/map.h.

## upper_bound() [1/4]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>
template<typename _Kt , typename _Req = typename __has_is_transparent<_Compare, _Kt>::type>

iterator std::__debug::map< _Key, _Tp, _Compare, _Allocator >::upper_bound | ( | const _Kt & | __x | ) |

inline

Definition at line 635 of file debug/map.h.

## upper_bound() [2/4]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>
template<typename _Kt , typename _Req = typename __has_is_transparent<_Compare, _Kt>::type>

const_iterator std::__debug::map< _Key, _Tp, _Compare, _Allocator >::upper_bound | ( | const _Kt & | __x | ) | const

inline

Definition at line 648 of file debug/map.h.

## upper_bound() [3/4]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::__debug::map< _Key, _Tp, _Compare, _Allocator >::upper_bound | ( | const key_type & | __x | ) |

inline

Definition at line 627 of file debug/map.h.

## upper_bound() [4/4]

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>

const_iterator std::__debug::map< _Key, _Tp, _Compare, _Allocator >::upper_bound | ( | const key_type & | __x | ) | const

inline

Definition at line 640 of file debug/map.h.

## Friends And Related Symbol Documentation

## ::__gnu_debug::_Safe_iterator

template<typename _Key , typename _Tp , typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>
template<typename _ItT , typename _SeqT , typename _CatT >

friend class ::__gnu_debug::_Safe_iterator

friend

Definition at line 60 of file debug/map.h.

The documentation for this class was generated from the following file:

- debug/map.h